interface StorageAdapter {
  <State>(key: string, update: (raw?: any) => any): {
    get(raw?: any, ctx?: any): State | Promise<State>
    set(value: State, ctx?: any): void
  }
  keyArea?: any
  noop?: boolean
}

interface StorageConfig {
  storage: () => Storage
  sync?: boolean | 'force'
  serialize?: (value: any) => string
  deserialize?: (value: string) => any
  timeout?: number
  def?: any
}
declare function storage({
  storage,
  sync,
  serialize,
  deserialize,
  timeout,
  def,
}: StorageConfig): StorageAdapter
declare namespace storage {
  var factory: true
}

export { StorageConfig, storage }
